
fun integrale f a b n =
  let val h = (b-a)/n in
  let fun integ x =
    if x >= b then 0.0 else f x + integ (x + h) in
  integ a * h end end
;

fun poly x = x * x
;

fun repeat n =
  if n <= 0 then 0.0 else (repeat (n-1); integrale poly 0.0 1.0 10000)
;

fun main x = (print (stdout,pack repeat 10); #put stdout "\n";());
