

datatype dterm1 = DV of int
       | DAPP of string * dterm list
withtype dterm = int * dterm1;

datatype codetree_no_q =
	 CT_TERM of (int -m> codetree_no_q ref) * (string -m> codetree_no_q ref)
       | CT_OK
	 ;

fun ctt_compile_dterm1 (DV x, ct) = CT_TERM ({x => ref ct}, {})
  | ctt_compile_dterm1 (DAPP (f, l), ct) =
    CT_TERM ({}, {f => ref (ctt_compile_dterml (l, ct))})
and ctt_compile_dterml (nil, ct) = ct
  | ctt_compile_dterml ((_, t)::l, ct) =
    ctt_compile_dterm1 (t, ctt_compile_dterml (l, ct));

val x = ctt_compile_dterm1 ( DAPP ("f",[(1,DAPP ("f",[(0,DV 1)]))]), CT_OK);

(*
 x should be
CT_TERM ({},
              {"f"
                => ref (CT_TERM ({},
                                 {"f"
                                   => ref (CT_TERM ({1 => ref CT_OK},{}))}))})
 *)
