/* Definitions of forms of iteration.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef enum IterKind {
  C_PROG, C_LIST, C_UNSHARED_LIST,
  C_SET, C_APPEND, C_UNSHARED_APPEND,
  C_UNION, C_UNION_UNDER, C_INTER, 
  C_MAP, C_MAP_UNDER,
  C_ALL, C_EXISTS, C_SOME, C_UNSHARED_SOME
} IterKind;
