/* static declarations for file transfer.c */
static void markVector P((ExprPtr, markFunc));
static void markByteCode P((byteCodeChunk *, markFunc));
static int cmpint P((ExprPtr, ExprPtr));
static int cmpgnrl P((const void *, const void *));
static Boolean flushmap P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr sortMap P((ExprPtr));
static void unmarkBucketList1 P((BucketPtr));
static void initWait P((void));
static void pushWait P((ExprPtr));
static ExprPtr popWait P((void));
static void outZone P((TZone *));
static void inZone P((TZone *));
static void addShared P((ExprPtr));
static ExprPtr getShared P((ExprPtr));
static void outTransferVec P((ExprPtr));
static long outInstrs P((register short *, register short *, Boolean));
static void outByteCode P((byteCodeChunk *));
static void outCrossRef P((ExprPtr));
static void outCrossDef P((ExprPtr));
static void outKindMark P((ExprPtr));
static void outTransfer1 P((ExprPtr));
static void outPatch P((ExprPtr));
static ExprPtr inLabeled P((int, ExprPtr));
static ExprPtr inShared P((int, ExprPtr));
static ExprPtr inIntT P((int));
static ExprPtr inRealT P((int));
static ExprPtr inString P((int));
static ExprPtr inVarRef P((void));
static ExprPtr inVarIntro P((void));
static ExprPtr inShCouple P((ExprKind, ExprPtr));
static ExprPtr inShData P((ExprPtr));
static ExprPtr inData P((void));
static ExprPtr inShCoupleRev P((ExprKind, ExprPtr));
static ExprPtr inShSingle P((ExprKind, ExprPtr));
static ExprPtr inSingle0 P((ExprKind));
static ExprPtr inShSingleMagic P((ExprKind, ExprPtr));
static ExprPtr inSingle0Magic P((ExprKind));
static ExprPtr inShVec P((ExprKind, ExprPtr));
static ExprPtr inVec0 P((ExprKind, ExprPtr));
static ExprPtr inClosure P((ExprKind, ExprPtr));
static ExprPtr inPatCheck P((ExprPtr));
static ExprPtr fakeStack P((void));
static ExprPtr inTypeAssum P((ExprPtr));
static ExprPtr inTypeState P((ExprPtr));
static ExprPtr inCompAssum P((ExprPtr));
static ExprPtr inBuildHeader P((ExprPtr));
static void unknownSweep P((char *, doExtDesc *));
static ExprPtr unknownLoad P((extDesc *, Boolean, ExprPtr, loadAction));
static ExprPtr inExternal P((int, ExprPtr));
static ExprPtr inMap1 P((ExprPtr));
static ExprPtr inMap P((ExprPtr));
static ExprPtr inByteCode P((ExprPtr));
static ExprPtr inTransfer1 P((ExprPtr));
static void inPatch P((ExprPtr, ExprPtr));
