/* This file created automatically by himmlx.
  Modify at our own risks.
  While himmlx is part of HimML and is licensed under the GPL,
  this file carries no rights and no guarantees from the author of HimML, Jean Goubault-Larrecq,
  or from Bull S.A., INRIA, CNRS, or ENS Cachan
  by virtue of it being produced by HimML.
  It may however be subject to a specific licence
  from the author of the source file(s) used to generated the present file.
*/

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#if OS==UNIX_SYS_V || OS==UNIX_BSD
#include <sys/errno.h>
#else
#include <errno.h>
#endif
#if OS==MAC
#ifdef MPW
#include <memory.h>
#include <segload.h>
#endif
#endif
#if OS==UNIX_SYS_V || OS==UNIX_BSD
#include <signal.h>
#endif
#ifdef HAS_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif
#ifdef THINK_C
#include <console.h>
#endif
#include <assert.h>

#include <himml/himmlx.h>

#define STRINGIFY(x) #x
#define HIMMLX_FILENAME STRINGIFY(args.mlx)

#undef NDEBUG
IMPORT ExprPtr ___sanonymous_s_1 P((IN CONST ExprPtr env, ...));
IMPORT ExprPtr __main_2 P((IN CONST ExprPtr env, ...));

#ifdef AMIGA_OS
static int __spin_loop=0;
#endif

PUBLIC ExprPtr ___sanonymous_s_1_consts[6];
DEF_PRIVATE_ACTION_1ARG(___sanonymous_s_1)
{
  ExprPtr res, *data = (ExprPtr *)ENV_UNDERLYING(env);
  M_VARCALL_CC(res,___sanonymous_s_1,data[0],ENV_ARITY(_env),data); return res;
}
ACTION_END
PUBLIC FUN_HEADER(___sanonymous_s_1)
{
  struct _x { COUNTER n; gcStackView *next; ExprPtr p[3]; } _x;
  if (STKFULL(_x))
    {
      COUNTER i, n = ENV_ARITY(env);
      ExprPtr *data = alloctmp ((n+1)*sizeof(ExprPtr));
      ExprPtr res;
      va_list _args;
      data[0] = env; VA_START; for (i=0; i<n; ) data[++i] = va_arg(_args,ExprPtr); va_end(_args);
      res = CallCC(ACTION_NAME(___sanonymous_s_1),(ExprPtr)data,true);
      freetmp(data);
      return res;
    }

  _x.n = 2; _x.p[0] = ENV_UNDERLYING(env); { FUN_COLLECT(FC_IGN); _x.p[1] = arg; }
  _x.next = theStackFrames;
  theStackFrames = (gcStackView *)&_x;
 /* BC_CLOSURE0 */
  _x.p[2] = MakeCompiled (E_COMPILED_CLOSURE, __main_2, NIL);
  _x.n += 1; /* BC_LET1 */
  {
    ExprPtr env = _x.p[0];
    EVARS(env)->expr[0] = _x.p[2];
    HITBARRIER(env);
  }
 /* BC_DROP */
  _x.n -= 1; /* BC_CONST */
  _x.p[2] = ___sanonymous_s_1_consts[5];
  _x.n += 1; /* BC_RETURN */
  _x.p[0] = _x.p[2];
  goto end;

end:
  theStackFrames = _x.next;
  return _x.p[0];
}

PUBLIC ExprPtr __main_2_consts[5];
DEF_PRIVATE_ACTION_1ARG(__main_2)
{
  ExprPtr res, *data = (ExprPtr *)ENV_UNDERLYING(env);
  M_VARCALL_CC(res,__main_2,data[0],ENV_ARITY(_env),data); return res;
}
ACTION_END
PUBLIC FUN_HEADER(__main_2)
{
  struct _x { COUNTER n; gcStackView *next; ExprPtr p[4]; } _x;
  if (STKFULL(_x))
    {
      COUNTER i, n = ENV_ARITY(env);
      ExprPtr *data = alloctmp ((n+1)*sizeof(ExprPtr));
      ExprPtr res;
      va_list _args;
      data[0] = env; VA_START; for (i=0; i<n; ) data[++i] = va_arg(_args,ExprPtr); va_end(_args);
      res = CallCC(ACTION_NAME(__main_2),(ExprPtr)data,true);
      freetmp(data);
      return res;
    }

  _x.n = 1; _x.p[0] = ENV_UNDERLYING(env);
  _x.next = theStackFrames;
  theStackFrames = (gcStackView *)&_x;
 /* BC_FUNCTION */
#if OS==AMIGA_OS
  if (++__spin_loop==32) { __spin_loop=0; chkabort(); }
#endif
 /* BC_GLOBVARREF */
  _x.p[1] = EVARS(GLOBENV)->expr[161];
  _x.n += 1; /* BC_GLOBVARREF */
  _x.p[2] = EVARS(GLOBENV)->expr[163];
  _x.n += 1; /* BC_CALL */
  _x.p[1] = ACTION_NAME(pretty)(ENV_CONS(QENV(_x.p[1]),1), _x.p[2]);
  _x.n -= 1; /* BC_GLOBVARREF */
  _x.p[2] = EVARS(GLOBENV)->expr[241];
  _x.n += 1; /* BC_CONST */
  _x.p[3] = __main_2_consts[3];
  _x.n += 1; /* BC_CALL */
  _x.p[2] = ACTION_NAME(getargs)(ENV_CONS(QENV(_x.p[2]),1), _x.p[3]);
  _x.n -= 1; /* BC_CONST */
  _x.p[3] = __main_2_consts[4];
  _x.n += 1; /* BC_PACK */
  _x.p[2] = MakePack (E_PACK, _x.p[2], _x.p[3]);
  _x.n -= 1; /* BC_CALL */
  _x.p[1] = (*ACTION(_x.p[1]))(ENV_CONS(QENV(_x.p[1]),1), _x.p[2]);
  _x.n -= 1; /* BC_DROP */
  _x.n -= 1; /* BC_GLOBVARREF */
  _x.p[1] = EVARS(GLOBENV)->expr[163];
  _x.n += 1; /* BC_NTH_1 */
  _x.p[1] = AVAL(_x.p[1])->expr[1];
 /* BC_CONST */
  _x.p[2] = __main_2_consts[3];
  _x.n += 1; /* BC_CALL */
  _x.p[1] = (*ACTION(_x.p[1]))(ENV_CONS(QENV(_x.p[1]),1), _x.p[2]);
  _x.n -= 1; /* BC_RETURN */
  _x.p[0] = _x.p[1];
  goto end;

end:
  theStackFrames = _x.next;
  return _x.p[0];
}

PUBLIC void __init_consts (l)
IN CONST ExprPtr l;
{
  ExprPtr e;

  e = CAR(l); l = CDR(l); memcpy (__main_2_consts, AVAL(e)->expr, 5 * sizeof(ExprPtr));
  e = CAR(l); l = CDR(l); memcpy (___sanonymous_s_1_consts, AVAL(e)->expr, 6 * sizeof(ExprPtr));
}
PUBLIC compiledAction __himmlx_code [] = {
  (compiledAction)___sanonymous_s_1, (compiledAction)__main_2,  NULL };
PUBLIC COUNTER _n__himmlx_code = 2;


PRIVATE char __himmlx_rawdata [] = {
  0x6, 0, 0x8b, 0, 0, '1', 0, 0, 0, 0, 0, 0, 0, 0, 0x6, 
  0, 0x6, 0, 0x8b, 0, 0, 's', 0, 0, 0, 0, 0, 0, 0, 0, 0x6, 
  0, 0xfd, 0, '&', 0x1, 0, 0xd, 0, 0, 0, 0, 0x5, 0x5, '@', 0, 0, 
  0, 0x8, '_', '_', 'm', 'a', 'i', 'n', '_', '2', 0x6, 0, '|', 0, 'b', 'a', 
  's', 'e', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0xfc, 0, '&', 0xfc, 0, '&', 0x6, 0, 0x6, 0, 
  0xfc, 0, '&', 0xfc, 0, '&', 0xfc, 0, '&', 0x89, 0, 0xfd, 0, '\'', 0x7, 0, 
  0xfc, 0, '\'', 0xfc, 0, '\'', 0xfd, 0, '.', '$', '@', 0xff, 0xfe, 0xfd, 0, ',', 
  '$', '@', 0xff, 0xfe, '\'', '@', 0, 0, 0, 0x2, 0x5, '@', 0, 0, 0, 0x4, 
  't', 'r', 'u', 'e', 0x5, '@', 0, 0, 0, 0x5, 'f', 'a', 'l', 's', 'e', 0xfc, 
  0, '&', 0xfc, 0, '&', 0xfc, 0, '&', 0xfc, 0, '\'', 0, 0, 0, 0, 0xfc, 
  0, '\'', 0xfc, 0, '\'', 0xfc, 0, '&', 0xfc, 0, '&', 0xfc, 0, '\'', 0xfc, 0, 
  '\'', 0xfc, 0, '\'', 0x88, 0, 0, 0, 0, 0, 0x1, 0, 0x8, '@', 0xfd, 0, 
  '5', '/', '@', 0xfd, 0, ')', 0x5, '@', 0, 0, 0, 0x4, '%', ' ', '-', '>', 
  0x6, '@', 0xfc, 0, '&', 0xfd, 0, '*', 0x6, '@', 0xfc, 0, '&', 0xfc, 0, '&', 
  0xfd, 0, '(', 0x5, '@', 0, 0, 0, 0x4, 'm', 'a', 'i', 'n', 0xfc, 0, '\'', 
  0xfc, 0, '\'', 0xfc, 0, '\'', 0xfc, 0, '\'', 0xfc, 0, '\'', 0xfc, 0, '&', 0xfc, 
  0, '&', 0xfc, 0, '\'', 0xfc, 0, '\'', 0xfc, 0, '\'', 0x8a, 0, 0, 0x8, '@', 
  0xfd, 0, '8', 0x6, '@', 0x2, '@', 0, 0, 0, 0, 0xfd, 0, '+', 0x2, '@', 
  0, 0, 0, 0x1, 0xfc, 0, '(', 0xfc, 0, '&', 0xfc, 0, '&', 0, 0, 0, 
  0x1, 0, 0, 0, 0x1, 0, 0, 0, 0x1, 0x8, '@', 0x8d, '@', 0, 0, 0, 
  0x1, 0x7f, 0, 0xfc, 0, '8', 0xfc, 0, '&', 0xfc, 0, '\'', 0xfc, 0, '&', 0xfc, 
  0, '&', 0, 0, 0, 0x8, 0x5, '@', 0, 0, 0, 0x4, 'a', 'r', 'g', 's', 
  0x1a, 0, 0, 0, 0, 0x1, 0xfc, 0, '&', 0xfc, 0, '&', 0xfd, 0, '9', 0x8b, 
  0, 0xff, 0xf5, 0, 0x5, 0, 0x7, 0, 0x9, 0, 0x16, 0x6, 0, 0xfc, 0, '(', 
  0xfd, 0, '7', 0x5, '@', 0, 0, 0, 0x7, 'a', 'r', 'g', 's', '.', 'm', 'l', 
  0xfd, 0, '-', 0xa, '@', 0xfd, 0, '0', '/', '@', 0x5, '@', 0, 0, 0, 0x5, 
  '%', 'l', 'i', 's', 't', 0x6, '@', '/', '@', 0x5, '@', 0, 0, 0, 0x7, '%', 
  's', 't', 'r', 'i', 'n', 'g', 0xfc, 0, '&', 0xfc, 0, '&', 0xd, 0, 0, 0, 
  0, 0x6, 0x5, '@', 0, 0, 0, 0x11, '_', '_', '_', 's', 'a', 'n', 'o', 'n', 
  'y', 'm', 'o', 'u', 's', '_', 's', '_', '1', 0xfc, 0, '&', 0xfc, 0, '\'', 0xfc, 
  0, '&', 0xfc, 0, '\'', 0xfc, 0, '&', 0x1d, 0, 0, 0, 0, 0, 0, 0, 
  0xfc, 0, '9', 0xfc, 0, '(', 0x6, 0, 0xfd, 0, ';', 0x8b, 0, 0xff, 0xf5, 0, 
  0, 0, 0, 0, 0, 0, 0, 0x6, 0, 0xfc, 0, '\'', 0xfd, 0, '<', 0x1a, 
  0, 0, 0, 0, 0x2, 0xfc, 0, '&', 0xfc, 0, '5', 0xfc, 0, '7', 0xfd, 0, 
  ':', '$', '@', 0xff, 0xff, 0xfc, 0, ',', 0xfc, 0, '&', 0x6, 0, 0xfc, 0, '&', 
  0xfc, 0, '7', 0x5, '@', 0, 0, 0, 0xb, '*', 'a', 'n', 'o', 'n', 'y', 'm', 
  'o', 'u', 's', '*', 0x6, 0, 0xfc, 0, '-', '}', 0, 0xfc, 0, '&', 0xfc, 0, 
  '&', 'G', 0, 0x8b, 0, 0, 0x9, 0, 0x6, 0, 0x7, 0, 0x4, 0, 0x16, 0xfd, 
  0, '6', 0x6, '@', 0xc, '@', 0xfc, 0, '&', 0xfd, 0, '3', 0x6, '@', 0xfc, 0, 
  '+', 0xfc, 0, '.', 0xfd, 0, '/', 0x6, '@', 0xfc, 0, '7', 0xfc, 0, '&', '}', 
  0, '}', 0, '-', 0, 0x8b, 0, 0, 0x9, 0, 0x6, 0, 0x6, 0, 0x5, 0, 
  '#', 0xfc, 0, '6', '.', 0, 0x8b, 0, 0, 0x9, 0, 0x7, 0, 0x7, 0, 0x5, 
  0, 0x15, 0xfc, 0, '6', '}', 0, '}', 0, '}', 0, 0xfc, 0, '-', '-', 0, 
  0x8b, 0, 0, 0x9, 0, 0x6, 0, 0x6, 0, 0x5, 0, 0x12, 0x6, '@', 0xc, '@', 
  '/', '@', 0xfc, 0, ')', 0x6, '@', 0xfd, 0, '1', '/', '@', 0x5, '@', 0, 0, 
  0, 0x8, '%', 'd', 'y', 'n', 'a', 'm', 'i', 'c', 0xfc, 0, '&', 0xfc, 0, '*', 
  0xfd, 0, '2', 0x6, '@', 0xfc, 0, '+', 0xfc, 0, ':', 0xfc, 0, '/', '{', 0, 
  0x8b, 0, 0, 0x9, 0, 0x6, 0, 0x6, 0, 0x14, 0, '"', 0x6, '@', 0xc, '@', 
  0xfc, 0, '1', 0xfc, 0, '2', 0xfc, 0, '/', 'A', 0, 0x8b, 0, 0, 0x9, 0, 
  0x7, 0, 0x7, 0, 0x5, 0, 0x12, 0x6, '@', 0xc, '@', 0xfc, 0, '5', 0xfc, 0, 
  '2', 0xfc, 0, '/', ')', '@', 0, 0, 0, 0x2, 0, 0, 0, 0xa1, 0xfd, 0, 
  '4', ')', '@', 0, 0, 0, 0x2, 0, 0, 0, 0xa3, '}', 0, 0xfc, 0, '0', 
  0x2, '@', 0, 0, 0, 0x2, 0xfc, 0, '4', '-', 0, 0x8b, 0, 0, 0x9, 0, 
  0x6, 0, 0x6, 0, 0x1a, 0, '!', 0x6, '@', 0xc, '@', 0xfc, 0, '0', 0xfc, 0, 
  '3', 0xfc, 0, '/', ')', '@', 0, 0, 0, 0x2, 0, 0, 0, 0xf1, 0xfc, 0, 
  '-',  0 };
#define N_HIMMLX_RAWDATA 896


#if OS==AMIGA_OS
long __stack = 10000L; /* minimum of stack space */
#include <signal.h>
#endif

#if OS==UNIX_SYS_V || OS==UNIX_BSD
#define OPT_EXPANDED
#else
#ifdef THINK_C
#undef OPT_EXPANDED
#else
#define OPT_EXPANDED
#endif
#endif

EXTERN COUNTER crtab_maxlines;

EXTERN int gcTraceFd;

EXTERN struct Expression *features,*featuresType;
EXTERN char maintenance[],creator[];
EXTERN long replay_size;
EXTERN COUNTER theRmargin;

EXTERN COUNTER nThreads,threadSize;
EXTERN INT maxCells;
EXTERN unsigned long ktuple2_hash_size,kons_hash_size,
  mapletkons_hash_size,mapkons_hash_size,
  int_hash_size;
EXTERN unsigned long data_hash_size,real_hash_size;
EXTERN unsigned long string_hash_size,array_hash_size;

EXTERN EXTENDED fone;

EXTERN struct Expression *nihil;

#if DEBUGGING
EXTERN COUNTER debugMode;
EXTERN Boolean debugEnabled;
#endif

PUBLIC int theArgc,theArgi,theArgi0=1;
PUBLIC char **theArgv;

PRIVATE void ml_getopt P((int argc,char **argv));
PRIVATE void usage P((IN Boolean fatalp));

/* Dummy variables needed by the rest of the HimML system: */
PUBLIC Boolean evaluatingp=false,stopwanted=false;
PUBLIC CHAR *yyfilename;
PUBLIC char *yytext = "";
PUBLIC int yynerrs = 0;
PUBLIC long yyoffset=0;
PUBLIC int yy_input_device=0; /* different from YY_INPUT_STDIN so that symbol
				 table is not printed after the bytecode is loaded. */

PUBLIC ExprPtr currentFile;
PUBLIC void setCurrentFile() {}
PUBLIC COUNTER initCommandMode = 1;
PUBLIC ExprPtr lexEnv, /* maps ids to precedences as E_INT */
  consEnv; /* sets of constructors */
PUBLIC SymPtr lexId,lexPath;
PUBLIC ExprPtr keepLexEnv,keepConsEnv;
PUBLIC Boolean unit_recognized=false;
PUBLIC COUNTER star_recognized=0;
PUBLIC COUNTER union_recognized=0;
PUBLIC void resetTracingYyLex() {}
PUBLIC void setTopEnv() {}
PUBLIC void ResetFiles(mark,flushRemText)
IN CONST char *mark;
IN Boolean flushRemText;
{
}
PUBLIC void yyinit() {}
PUBLIC void CloseFile() {}
/* End of dummy variables. */

PUBLIC void setConstructor(name)
IN CONST ExprPtr name;
{
  setcarMapPut(name,UNIT,consEnv);
}

PRIVATE ExprPtr copyEnv1(env)
IN CONST ExprPtr env;
{
  env = Nreverse(env);
  return Nreverse(env);
}

PUBLIC ExprPtr copyLexEnv()
{
  ExprPtr e;
  ENTER;

  e = copyEnv1(lexEnv);
  KEEPONLY(e);
  return e;
}

PUBLIC ExprPtr copyConsEnv()
{
  ExprPtr e;
  ENTER;

  e = copyEnv1(consEnv);
  KEEPONLY(e);
  return e;
}

PUBLIC char *getMarkFiles()
{
  return NULL;
}

PUBLIC OPCODE DoBreak(bc, pc, top, bcframes, stacks, exc)
IN CONST struct byteCodeChunk *bc;
IN CONST OPCODE *pc;
IN CONST ExprPtr *top;
IN CONST struct bcframes *bcframes;
IN CONST struct bcstacks *stacks;
IN CONST ExprPtr exc;
{
  exit(2);
}

PUBLIC void restoreBreaks () {}
PUBLIC void reinstallBreaks () {}

EXTERN ExprPtr theSyntax;

READFUNC(readstring)
{
  REGISTER INT *cnt;
  COUNTER maxlen;

  cnt = READDATA(INT *);
  maxlen = N_HIMMLX_RAWDATA - (*cnt);
  if (len > maxlen)
    {
      errno = EIO; /* so that inTransfer1() detects a problem. */
      return;
    }
  if (len>0)
    {
      memcpy (text, __himmlx_rawdata+(*cnt), len);
      *cnt += len;
    }
}

PRIVATE ExprPtr keep_l;

PUBLIC int yyparse P((void))
{
  TZone *zone;
  ExprPtr res,aux,l, res_lr;
  INT *cnt;
  ENTER;

  zone = (TZone *)alloctmp_anchored(sizeof(TZone),(char *)&res);
  zone->line1 = zone->line2 = zone->pos1 = zone->pos2 = 0;
  yyfilename = (CHAR *)HIMMLX_FILENAME;
  cnt = (INT *)alloctmp_anchored(sizeof(INT),(char *)&res);
  *cnt = 0;
  res_lr = inTransfer (readstring, (char *)cnt);
  res = CAR(res_lr);
  __init_consts (CDR(res_lr));
  SETREFVAL(keep_l, CDR(res_lr)); /* to prevent GC from reclaiming the contents
				     of the *_consts[] tables. */
  KEEPONLY(res);
  if (res==NIL)
    {
      int len = strlen (HIMMLX_FILENAME);
      char *buf = alloctmp_anchored(len+64,(char *)&res);

      sprintf(buf,message(921), HIMMLX_FILENAME);
      type_error(zone,buf);
      return 1;
    }
  theSyntax = res;
  return 0;
}

EXTERN SymPtr funSym;

PRIVATE void MLRun(data)
char *data;
{
#if DEBUGGING
  currentFile = NIL;
#endif
  lexEnv = consEnv = NIL;
  pushEnv ();
  lexId = lexPath = NIL;
  keepLexEnv = keepConsEnv = NIL;
  keep_l = MakeSing (E_REF, NIL);
  (void) KEEP(keep_l);
  (void) HimMLParse();
  {
    SymPtr mainSym;
    ExprPtr type;

    mainSym = Ksymbol(message(927));
    type = varType (mainSym,basisAssum,basisState
#if IMPERATIVE_TYPES!=EFFECT_TYVAR
		    ,false
#endif
		    );
    if (type==NOEXPR)
      berror ("cannot find main ().\n");
    if (type->kind==(CHAR)E_TYPE_APPL && fxSym(APPLFUN(type))==funSym && CAR(APPLARG(type))==NIL)
      { /* of type unit -> ? */
	ExprPtr i_l;

	i_l = MapGetSure (mainSym, IdLocs(basisTable));
	if (i_l->kind==(CHAR)E_INT)
	  {
	    COUNTER i;
	    ExprPtr prog;

	    i = IVAL(i_l);
	    prog = EVARS(GLOBENV)->expr[i];
	    evaluatingp = true;
	    (void) (*ACTION(prog))(ENV_CONS(QENV(prog),0));
	    exit (0);
	  }
	else berror ("internal bug, cannot find main in toplevel environment.\n");
      }
    else berror ("main() should be of type unit -> t for some type t.\n");
  }
  /*!!! now run "main (); quit 0;" */
}

PRIVATE NORETURN void loop P((int argc, char *argv[])) _NORETURN;

PRIVATE NORETURN void loop(argc,argv)
int argc;
char *argv[];
{
  /* this function executes in a much lowered stack;
     above are all the stacks devoted to threads in ML.
     When you call doML, it reestablishes one of these
     stacks, and on return comes back to the point where
     doML was called. */
  int i;

#if OS==MAC
  MaxApplZone();
  UnloadSeg(InitML);
#if DEBUGGING
  UnloadSeg(InitDebug);
#endif
#endif
  debugEnabled = false;
#if OS==UNIX_SYS_V || OS==UNIX_BSD
  signal(2,ml_break);
  signal(3,ml_done);
  signal(SIGTERM,ml_done);
#ifdef SIGFPE
  signal(SIGFPE,ml_fpe);
#endif
#endif
#if OS==AMIGA_OS
  signal(SIGINT,ml_break);
  signal(SIGTERM,ml_done);
  signal(SIGFPE,ml_fpe);
#endif
  for (;;)
    doML(MLRun,(char *)0L);
}

int main(argc,argv)
int argc;
char *argv[];
{
#ifdef THINK_C
  argc = ccommand(&argv);
#endif
#if OS==AMIGA_OS
  argv[0] = HIMMLX_FILENAME;
#endif
  ml_getopt(argc,argv);
  InitML(loop,argc,argv);
  return 0;
}

typedef struct Command {
  char *key;
  void (*do_) P((void));
  char *doc;
  long xmask; /* the command (number #j) cannot be used if the command #i
		    has been used before, for 1<<i in xmask;
		    in particular, if j=i, the command may be reused
		    only if 1<<i is not in xmask */
}   Command;

PRIVATE void do_initmemsize()
{
  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&replay_size)!=1)
    {
      fprintf(stderr,message(98));
      ml_done(10);
    }
}

PRIVATE void do_initusage()
{
  usage(false);
  ml_done(0);
}

PRIVATE void do_rmargin()
{
  int n = theRmargin;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%d",&n)!=1)
    {
      fprintf(stderr,message(103));
      ml_done(10);
    }
  theRmargin = (COUNTER)n;
}

PRIVATE void do_growfactor()
{
  double grow;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%lf",&grow)!=1 || grow<=fone)
    {
      fprintf(stderr,message(104));
      ml_done(10);
    }
  installGrowFactor(&grow);
}

PRIVATE void do_maxgrowfactor()
{
  double grow;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%lf",&grow)!=1 || grow<=fone)
    {
      fprintf(stderr,message(104));
      ml_done(10);
    }
  installMaxGrowFactor(&grow);
}

PRIVATE void do_nthreads()
{
  int n = nThreads;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%d",&n)!=1)
    {
      fprintf(stderr,message(475));
      ml_done(10);
    }
  if (n<3)
    {
      fprintf(stderr,message(476));
      ml_done(10);
    }
  nThreads = n;
}

PRIVATE void do_threadsize()
{
  int n = threadSize;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%d",&n)!=1 || n<2000)
    {
      fprintf(stderr,message(478));
      ml_done(10);
    }
  threadSize = n;
}

PRIVATE void do_maxcells()
{
  long i = maxCells;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1024)
    {
      fprintf(stderr,message(793));
      ml_done(10);
    }
  maxCells = i;
}

PRIVATE void do_gctrace()
{
  char *file;

  if (theArgi>=theArgc)
    {
      fprintf(stderr,message(613));
      ml_done(10);
    }
  file = theArgv[theArgi++];
  gcTraceFd = open(file,O_CREAT | O_TRUNC | O_WRONLY, 0666);
  if (gcTraceFd==-1)
    {
      fprintf(stderr,message(614),file);
      ml_done(10);
    }
}

PRIVATE void do_pair_hash_size()
{
  unsigned long i = ktuple2_hash_size;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1)
    {
      fprintf(stderr,message(655),(unsigned long)KTUPLE2_HASH_SIZE);
      ml_done(10);
    }
  ktuple2_hash_size = i;
  kons_hash_size = i;
  mapletkons_hash_size = i;
  mapkons_hash_size = i;
}

PRIVATE void do_data_hash_size()
{
  unsigned long i = data_hash_size;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1)
    {
      fprintf(stderr,message(673),(unsigned long)DATA_HASH_SIZE);
      ml_done(10);
    }
  data_hash_size = i;
}

PRIVATE void do_int_hash_size()
{
  unsigned long i = int_hash_size;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1)
    {
      fprintf(stderr,message(657),(unsigned long)INT_HASH_SIZE);
      ml_done(10);
    }
  int_hash_size = i;
}

PRIVATE void do_real_hash_size()
{
  unsigned long i = real_hash_size;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1)
    {
      fprintf(stderr,message(658),(unsigned long)REAL_HASH_SIZE);
      ml_done(10);
    }
  real_hash_size = i;
}

PRIVATE void do_string_hash_size()
{
  unsigned long i = string_hash_size;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1)
    {
      fprintf(stderr,message(659),(unsigned long)STRING_HASH_SIZE);
      ml_done(10);
    }
  string_hash_size = i;
}

PRIVATE void do_array_hash_size()
{
  unsigned long i = array_hash_size;

  if (theArgi>=theArgc || sscanf(theArgv[theArgi++],"%ld",&i)!=1 || i<1)
    {
      fprintf(stderr,message(660),(unsigned long)ARRAY_HASH_SIZE);
      ml_done(10);
    }
  array_hash_size = i;
}

PRIVATE Command command[] = {
/* 0 */ { "-mem", do_initmemsize, " memory-size", 0x00000001L },
/* 1 */	{ "-col", do_rmargin, " number-of-columns", 0x00000002L },
/* 2 */	{ "-grow", do_growfactor, " memory-grow-factor", 0x00000004L },
/* 3 */	{ "-maxgrow", do_maxgrowfactor, " max-memory-grow-factor", 0x00000008L },
/* 4 */ { "-nthreads", do_nthreads, " max-cached-threads", 0x00000010L },
/* 5 */ { "-threadsize", do_threadsize, " thread-cache-size", 0x00000020L },
/* 6 */ { "-maxcells", do_maxcells, " max-cells", 0x00000040L },
/* 7 */ { "?", do_initusage, "", 0x000000000L },
/* 8 */ { "-gctrace", do_gctrace, " file-name", 0x00000100L },
/* 9 */ { "-pair-hash-size", do_pair_hash_size, " #entries", 0x00000200L },
/*10 */ { "-int-hash-size", do_int_hash_size, " #entries", 0x00000400L },
/*11 */ { "-real-hash-size", do_real_hash_size, " #entries", 0x00000800L },
/*12 */ { "-string-hash-size", do_string_hash_size, " #entries", 0x00001000L },
/*13 */ { "-array-hash-size", do_array_hash_size, " #entries", 0x00002000L },
/*14 */ { "-data-hash-size", do_data_hash_size, " #entries", 0x00004000L, },
	{ NULL, NULL }
};

PRIVATE long requiredMask = 0L; /* the xmask of mandatory options */

PRIVATE char errbuf[512];

PRIVATE void ml_getopt(argc,argv)
int argc;
char *argv[];
{
  Command *com;
  char *s;
  long xmask,mask,m;
  int i;
  Boolean start;

  theArgc = argc;
  theArgv = argv;
  /*replay_mode = false;*/
  xmask = 0L;
  for (theArgi = 1; theArgi<theArgc; )
    {
      if (!strcmp(theArgv[theArgi], "--"))
	{
	  while (++theArgi < theArgc)
	    {
	      theArgv[theArgi0++] = theArgv[theArgi];
	    }
	  break;
	}
      for (com=command, mask=1L; com->key!=NULL; com++, mask <<= 1)
	if (!strcmp(theArgv[theArgi],com->key))
	  {
	    if ((m = (com->xmask & xmask)))
	      {
		start = true;
		if (xmask & mask)
		  sprintf(errbuf,message(105),theArgv[theArgi]);
		else
		  {
		    sprintf(errbuf,message(106),theArgv[theArgi]);
		    s = errbuf+strlen(errbuf);
		    for (i=0; m!=0L; i++)
		      {
			if (m & 1)
			  {
			    if (start)
			      start = false;
			    else if (m!=0L && (m & (-m))==m)
			      strcpy(s,message(107));
			    else
			    strcpy(s,message(108));
			    s += strlen(s);
			    sprintf(s,"%s",command[i].key);
			    s += strlen(s);
			  }
			m >>= 1;
		      }
		  }
		{
		  fprintf(stderr,errbuf);
		  fprintf(stderr,"\n");
		  ml_done(10);
		}
	      }
	    theArgi++;
	    xmask |= mask;
	    (*com->do_)();
	    break;
	  }
      if (com->key==NULL)
	{
	  theArgv[theArgi0++] = theArgv[theArgi++];
	}
    }
  if ((m = (requiredMask & (~xmask))))
    {
      start = true;
      
      sprintf(errbuf, ((m & (-m))==m)?message(110):message(111));
      s = errbuf+strlen(errbuf);
      for (i=0; m!=0L; i++)
	if (m & 1)
	  {
	    m >>= 1;
	    if (start)
	      start = false;
	    else if (m!=0L && (m & (-m))==m)
	      strcpy(s,message(107));
	    else
	      strcpy(s,message(108));
	    s += strlen(s);
	    sprintf(s,"%s",command[i].key);
	    s += strlen(s);
	  }
      {
	fprintf(stderr,errbuf);
	ml_done(10);
      }
    }
  theArgc = theArgi0;
  theArgi = 1;
}

PRIVATE void usage(fatalp)
IN Boolean fatalp;
{
  char *s;
  Command *com;
  long mask;

  sprintf(errbuf, "usage: %s", HIMMLX_FILENAME);
  s = errbuf+strlen(errbuf);
  for (com=command, mask = 1L; com->key!=NULL; com++, mask <<= 1)
    {
      sprintf(s,(requiredMask & mask)?" %s%s":" [%s%s]",com->key,com->doc);
      s += strlen(s);
    }
  sprintf (s, " arguments");
  s += strlen (s);
  *s++ = '\n';
  *s = 0;
  fprintf(stderr,errbuf);
  if (fatalp)
    ml_done(10);
}

#ifdef SIGFPE
void ml_fpe(code)
int code;
{
  while (true)
    Raise(ARITHEXC); /* cannot get back result,
			so raise exception ad infinitum;
			this is not very smart, but what
			else can we do ? */
}
#endif
