
extern datatype 'a IntSet;

exception IntSet;

extern val intset_funs : ('a * 'a -> bool) * ('a * 'a -> bool) * 'a
	   -> |[
		 inter : 'a IntSet * 'a IntSet -> 'a IntSet,
		 union : 'a IntSet * 'a IntSet -> 'a IntSet,
		 diff : 'a IntSet * 'a IntSet -> 'a IntSet,
		 must_be_in : 'a * 'a IntSet -> bool,
		 must_not_be_in : 'a * 'a IntSet -> bool,
		 may_be_in : 'a * 'a IntSet -> bool,
		 may_not_be_in : 'a * 'a IntSet -> bool,
		 open_interval : 'a -> 'a IntSet,
		 interval : 'a * 'a -> 'a IntSet,
		 shift : ('a -> 'a) -> 'a IntSet -> 'a IntSet,
		 empty : 'a IntSet -> bool,
		 equal : 'a IntSet * 'a IntSet -> bool
		 ]|;
